#include <stdio.h>
#include <apollo/base.h>
#include <apollo/gpr.h>
#include <tml/tml_objects.hxx>
#include <tml/tml_functions.hxx>
#include <tml/tml_dp_graph.hxx>

#ifdef __cplusplus
extern "C" long create_bitmap();
extern "C" void enable_all_keys();
#endif

extern long create_bitmap();
extern void enable_all_keys();

main()
{
    model          *display_model;
    view_port      *display_viewport;
    format         *display_format;
    model_pos       start_display;
    long            bitmap_desc;
    char            unob;
    gpr_$event_t    ev_type;
    char            ev_value;
    gpr_$position_t ret_coord;
    status_$t       status;

    /* associate all viewport objects with the GPR graphic system */
    tml_dp_set_dflt_vpftbl(tml_dp_get_gpr_vpftbl());

    /* create a model from the ASCII file test_file */
    display_model = read_uasc("test_file", 9);

    /* allocate a viewport */
    display_viewport = new view_port;
    /* create a graphics display area, using a routine which depends */
    /*   on the graphics system being used */
    bitmap_desc = create_bitmap();

    /* assign the display area to the viewport */
    display_viewport->set_handle(&bitmap_desc);

    /* create a format and attach it to the viewport */
    display_viewport->attach((format*) 0);
    /* get a handle to the format created by the last call */
    display_format = display_viewport->get_format();
    /* attach the model to the format associated with the viewport */
    display_format->attach(display_model);

    /* fill viewport with text; first character placed at pixel (0,0) */
    tml_dp_damage_repair(display_viewport->get_handle());

    /* enable keyboard */
    enable_all_keys();

    /* wait for input, then exit */
    unob = gpr_$event_wait(&ev_type, (unsigned char*) &ev_value,
                           &ret_coord, &status);

    delete display_viewport;
    delete display_format;
    delete display_model;
}

