#include <stdio.h>
#include <tml/tml_c_types.h>
#include <tml/tml_os_depends.h>

    /*****************************************/
#include <dlg/Xlib.h>
#include <dlg/Xutil.h>
#include <tml/tml_dp_x_graph.h>
#include <tml/tml_dp_graph.hxx>

#ifdef not_vanilla_C
extern struct window_info* make_window(long mask_selection);
extern char                x_exam_getchar(Display *display,
                                          tml_c_view_port display_viewport);
#else
extern struct window_info* make_window();
extern char                x_exam_getchar();
#endif

main()
{
    tml_c_model      display_model;
    tml_c_view_port  display_viewport;
    tml_c_format     display_format;
    C_MODEL_POS      start_display;
    long             mask_selection =
                       KeyPressMask |       /* Ask XWindows for notice */
                       ExposureMask |       /* of key, expose, and */
                       StructureNotifyMask; /* window size and location */
                                            /* change events */

    /***************************************/
    struct window_info   *window_desc;
    /***************************************/

    /* initialize TMLib */
    tml_init();


    /***************************************/
    /* set up XWindows */
    /* get information needed about display, etc. */
    window_desc = make_window(mask_selection);
    if (!window_desc){
        fprintf(stderr, "unable to initialize X\n");
        exit(1);
        }
    /* set font display */
    /* MUST BE DONE BEFORE CREATING A MODEL */
    tml_dp_set_font_display(window_desc->display);
    /***************************************/

    /* create a model from the ASCII file test_file */
    display_model = tml_c_read_uasc_path("test_file", 9);
    if (!display_model)
        exit (1);

    /* allocate a viewport */
    display_viewport = view_port_class_alloc();

    /* assign the display area to the viewport */
    view_port_set_handle(display_viewport, window_desc);

    /* create a format */
    /* attach it to the viewport */
    view_port_attach_format(display_viewport, 0, 0, 0);
    /* get a handle to the format created by the last call */
    display_format = view_port_get_format(display_viewport);
    /* attach the model to the format that is associated with the viewport */
    format_attach(display_format, display_model);

    /* wait for input, then exit */
    x_exam_getchar(window_desc->display, display_viewport);

    view_port_free( display_viewport);
    format_free( display_format);
    model_free( display_model);
}

