#include <dlg/Xlib.h>
#include <dlg/Xutil.h>
#include <tml/tml_dp_x_graph.h>

#ifdef not_vanilla_C
struct window_info *make_window(long mask_selection)
#else
struct window_info *make_window(mask_selection)
    long mask_selection;
#endif
{
    struct window_info *return_info;  /* from tml_dp_x_graph.h */
                                      /*  -- info needed by TMLib */
    XSizeHints          hints;        /* information giving X hints */
                                      /*  about initial window sizes */
    unsigned int        foreg, backg; /* foreground and background colors */
    int                 myscreen;     /* the screen to use */

    /* allocate space for information needed by TMLib */
    return_info =
      (struct window_info *) tml_c_tml_os_alloc(
                               (unsigned long) 1,
                               (unsigned long) sizeof(struct window_info));
    if (!return_info)
        return 0;

    /* set up information related to XWindows */
    return_info->display = XOpenDisplay("");
    if (!return_info->display){
        tml_c_tml_os_free((char*) return_info);
        return 0;
        }
    myscreen = DefaultScreen(return_info->display);
    foreg = BlackPixel(return_info->display, myscreen);
    backg = WhitePixel(return_info->display, myscreen);
    hints.x = 50;
    hints.y = 50;
    hints.width = 300;
    hints.height = 300;
    hints.flags = PPosition | PSize;
    /* create the window */
    return_info->window =
      XCreateSimpleWindow(return_info->display,
                          DefaultRootWindow(return_info->display),
                          hints.x, hints.y, hints.width, hints.height,
                          5, foreg, backg);
    XSetStandardProperties(return_info->display, return_info->window,
                           "test", "test", None, 0, 0, &hints);
    /* create a graphics context */
    /* set foreground and background colors */
    return_info->gc = XCreateGC(return_info->display,
                                return_info->window, 0, 0);
    XSetBackground(return_info->display, return_info->gc, backg);
    XSetForeground(return_info->display, return_info->gc, foreg);
    /* fill in remainder of window_info structure */
    return_info->depth = DefaultDepth(return_info->display, myscreen);
    return_info->creation_x_size = hints.width;
    return_info->creation_y_size = hints.height;
    /* ask XWindows for notice of input, window exposures, window mapping */
    XSelectInput(return_info->display, return_info->window, mask_selection);
    /* map the window */
    XMapRaised(return_info->display, return_info->window);
    return return_info;
    }
