#include <stdio.h>
#include <tml/tml_objects.hxx>
#include <tml/tml_functions.hxx>

    /*****************************************/
#include <dlg/Xlib.h>
#include <dlg/Xutil.h>
#include <tml/tml_dp_x_graph.h>
#include <tml/tml_dp_graph.hxx> /* graphics system call profiles */

extern window_info* make_window(long mask_selection);
extern char         x_exam_getchar(Display *display,
                                   view_port *display_viewport);

main()
{
    model     *display_model;
    view_port *display_viewport;
    format    *display_format;
    long       mask_selection = KeyPressMask |       /* Ask XWindows for */
                                ExposureMask |       /* notice of key, */
                                StructureNotifyMask; /* expose, and window */
                                                     /* size and location */
                                                     /* change events */
    /***************************************/
    window_info *window_desc;
    /***************************************/

    /***************************************/
    /* set up XWindows */
    /* get information needed about display, etc. */
    window_desc = make_window(mask_selection);
    if (!window_desc) {
        fprintf(stderr, "unable to initialize X\n");
        exit(1);
        }
    /* set the font display */
    /* MUST BE DONE BEFORE CREATING A MODEL */
    tml_dp_set_font_display(window_desc->display);
    /***************************************/

    /* create a model from the ASCII file test_file */
    display_model = read_uasc("test_file", 9);

    /* allocate a viewport */
    display_viewport = new view_port;

    /* assign the display area to the viewport */
    display_viewport->set_handle(window_desc);

    /* create a format, and attach it to the viewport */
    display_viewport->attach((format*) 0);
    /* get a handle to the format created by the last call */
    display_format = display_viewport->get_format();
    /* attach the model to the format that is associated with the viewport */
    display_format->attach(display_model);

    /* wait for input, then exit */
    x_exam_getchar(window_desc->display, display_viewport);

    delete display_viewport;
    delete display_format;
    delete display_model;
}
