/**************************************************************************************
    d_ptr_traits.cxx
    functions for encoding and decoding disk-format pseudo-pointers

    (c) Copyright Apollo Computer Inc., 1987 (unpublished)
     --------------------------------------------------------------------
    |THE FOLLOWING PROGRAMS ARE THE SOLE PROPERTY OF APOLLO COMPUTER INC.|
    |      AND CONTAIN ITS PROPRIETARY AND CONFIDENTIAL INFORMATION.     |
     --------------------------------------------------------------------
**************************************************************************************/

#include <stdio.h>
#ifndef tml_d_ptr_hxx
#include <tml/tml_d_ptr.hxx>
#endif

/* derive a d_ptr (disk save pseudo-pointer) from a real tml type pointer */
/*   see tml_objects.hxx for declaration of d_ptr */
void d_ptr::get_d_ptr(char *mem_ptr, CHARP *heap_set)
{
   long i;
   char *cur_heap;

    if (NULL == mem_ptr) {            // a d_ptr with heap == 0 and offset == 0 means the
        heap = (HALF_PTR) -1;       //   object referred to begins at 0 offset of the first
        offset = (HALF_PTR) -1;     //   heap, so use -1 for both
        return;
        }
    i = 0;
    while (NULL !=  (cur_heap = *(heap_set + i))) {
        if (cur_heap > mem_ptr)
            break;
        i++;
        }
    if (NULL == cur_heap || 0 == i)
        printf("pointer out of range\n");
    else
        cur_heap = *(heap_set + --i);
    heap = (HALF_PTR) i;
    offset = (HALF_PTR) (mem_ptr - cur_heap);
}


/* return a d_ptr's contents as a WHOLE_PTR */
WHOLE_PTR d_ptr::as_whole_ptr()
{
    WHOLE_PTR retval;

    retval = heap << BITS_IN_HALF_PTR;
    retval |= offset;
    return(retval);
}


/* obtain the memory pointer associated with a d_ptr */
void *d_ptr::get_m_ptr(CHARP *table)
{
    char *temp;

    if ((((HALF_PTR)-1) == heap) && (((HALF_PTR) -1) == offset))
        return((void *) NULL);
    else {
        temp = *(table + heap) + offset;
        return((void *)  temp);
        }
}


