/**************************************************************************************
    File dflt_view_funcs.hxx
    Declarations of default values for table of rendering functions

    (c) Copyright Apollo Computer Inc., 1987 (unpublished)
     --------------------------------------------------------------------
    |THE FOLLOWING PROGRAMS ARE THE SOLE PROPERTY OF APOLLO COMPUTER INC.|
    |      AND CONTAIN ITS PROPRIETARY AND CONFIDENTIAL INFORMATION.     |
     --------------------------------------------------------------------
**************************************************************************************/

#ifndef dflt_view_funcs_hxx
#define dflt_view_funcs_hxx

#include <tml/tml_cxx2.0_linkage_decls.hxx>
#include <tml/tml_prototype_status.h>

#ifdef not_vanilla_C
/*default values for default table of rendering functions (Xwindows)*/
extern char*   tml_dp_x_get_default_font(long& name_len);
extern void*   tml_dp_x_get_fhandle(char *font_name, long name_len);
extern long    tml_dp_x_load_font(void *font_handle);
extern long    tml_dp_x_get_fcharsize(void *font_handle);
extern long    tml_dp_x_get_fcharnum(void *font_handle);
extern long    tml_dp_x_get_fchar1(void *font_handle);
extern long    tml_dp_x_get_fhi(void *font_handle);
extern long    tml_dp_x_get_fpoint(void *font_handle);
extern long    tml_dp_x_get_fbline(void *font_handle);
extern long    tml_dp_x_is_fixed(void *font_handle);
extern short** tml_dp_x_get_fwidths(void *font_handle);
extern long    tml_dp_x_get_ficspace(void *font_handle);
extern long    tml_dp_x_set_ficspace(void *font_handle, long new_icspace);
extern long    tml_dp_x_get_fspace(void *font_handle);
extern void    tml_dp_x_set_fspace(void *font_handle, long new_space);
extern long    tml_dp_x_funload(void *font_handle);
extern void    tml_dp_x_frelease(void *font_handle);
extern void*   tml_dp_x_make_graphic_handle(void *bitmap_id, void *viewport_id);
extern void    tml_dp_x_delete_graphic_handle(void *bitmap_id);
extern long    tml_dp_x_get_hi(void *bitmap_id);
extern long    tml_dp_x_get_wide(void *bitmap_id);
extern long    tml_dp_x_get_foreg_id(void *bitmap_id);
extern long    tml_dp_x_get_backg_id(void *bitmap_id);
extern long    tml_dp_x_get_fill_backg_id(void *bitmap_id);
extern long    tml_dp_x_get_fill_obj_id(void *bitmap_id);
extern void    tml_dp_x_set_foreg_id(void *bitmap_id, long new_fg_id);
extern void    tml_dp_x_set_backg_id(void *bitmap_id, long new_bg_id);
extern void    tml_dp_x_set_fill_backg_id(void *bitmap_id, long new_fill_bg_id);
extern void    tml_dp_x_set_fill_obj_id(void *bitmap_id, long new_fill_obj_id);
extern void    tml_dp_x_set_clip(void *bitmap_id, long clip_ulx, long clip_uly, long clip_lrx, long clip_lry);
extern void    tml_dp_x_clear_clip(void *bitmap_id);
extern void    tml_dp_x_clear(void *bitmap_id, long ulx, long uly, long lrx, long lry);
extern void    tml_dp_x_copy(void *bitmap_id, long src_ulx, long src_uly, long src_lrx, long src_lry, long dst_ulx, long dst_uly);
extern void    tml_dp_x_blt(void *bitmap_id, long src_ulx, long src_uly, long src_lrx, long src_lry, long dst_ulx, long dst_uly, long rop_id);
extern long    tml_dp_x_string_draw(void *bitmap_id, char *string, long st_count, long wherex, long wherey, void *use_font);
extern long    tml_dp_x_string_size(char *string, long st_count, void *use_font);
extern void    tml_dp_x_damage_repair(void *bitmap_id);
extern long    tml_dp_x_dflt_cursor_draw(void *bitmap_id, long wherex, long wherey,
                                         long height, long width, long erase);
extern void*   tml_dp_x_get_grafsys_obj(void* bitmap_id);
extern char*   get_x_default_font_name(void* display, long* length);
extern char*   set_x_default_font_name(void* display, long* length, char* font_name);

/*values for default table of rendering functions (GPR) */
#ifdef apollo
extern char*   tml_dp_gpr_get_default_font(long& name_len);
extern void*   tml_dp_gpr_get_fhandle(char *font_name, long name_len);
extern long    tml_dp_gpr_load_font(void *font_handle);
extern long    tml_dp_gpr_get_fcharsize(void *font_handle);
extern long    tml_dp_gpr_get_fcharnum(void *font_handle);
extern long    tml_dp_gpr_get_fchar1(void *font_handle);
extern long    tml_dp_gpr_get_fhi(void *font_handle);
extern long    tml_dp_gpr_get_fpoint(void *font_handle);
extern long    tml_dp_gpr_get_fbline(void *font_handle);
extern long    tml_dp_gpr_is_fixed(void *font_handle);
extern short** tml_dp_gpr_get_fwidths(void *font_handle);
extern long    tml_dp_gpr_get_ficspace(void *font_handle);
extern long    tml_dp_gpr_set_ficspace(void *font_handle, long new_icspace);
extern long    tml_dp_gpr_get_fspace(void *font_handle);
extern void    tml_dp_gpr_set_fspace(void *font_handle, long new_space);
extern long    tml_dp_gpr_funload(void *font_handle);
extern void    tml_dp_gpr_frelease(void *font_handle);
extern void*   tml_dp_gpr_make_graphic_handle(void *bitmap_id, void *viewport_id);
extern void    tml_dp_gpr_delete_graphic_handle(void *bitmap_id);
extern long    tml_dp_gpr_get_hi(void *bitmap_id);
extern long    tml_dp_gpr_get_wide(void *bitmap_id);
extern long    tml_dp_gpr_get_foreg_id(void *bitmap_id);
extern long    tml_dp_gpr_get_backg_id(void *bitmap_id);
extern long    tml_dp_gpr_get_fill_backg_id(void *bitmap_id);
extern long    tml_dp_gpr_get_fill_obj_id(void *bitmap_id);
extern void    tml_dp_gpr_set_foreg_id(void *bitmap_id, long new_fg_id);
extern void    tml_dp_gpr_set_backg_id(void *bitmap_id, long new_bg_id);
extern void    tml_dp_gpr_set_fill_backg_id(void *bitmap_id, long new_fill_bg_id);
extern void    tml_dp_gpr_set_fill_obj_id(void *bitmap_id, long new_fill_obj_id);
extern void    tml_dp_gpr_set_clip(void *bitmap_id, long clip_ulx, long clip_uly, long clip_lrx, long clip_lry);
extern void    tml_dp_gpr_clear_clip(void *bitmap_id);
extern void    tml_dp_gpr_clear(void *bitmap_id, long ulx, long uly, long lrx, long lry);
extern void    tml_dp_gpr_copy(void *bitmap_id, long src_ulx, long src_uly, long src_lrx, long src_lry, long dst_ulx, long dst_uly);
extern void    tml_dp_gpr_blt(void *bitmap_id, long src_ulx, long src_uly, long src_lrx, long src_lry, long dst_ulx, long dst_uly, long rop_id);
extern long    tml_dp_gpr_string_draw(void *bitmap_id, char *string, long st_count, long wherex, long wherey, void *use_font);
extern long    tml_dp_gpr_string_size(char *string, long st_count, void *use_font);
extern void    tml_dp_gpr_damage_repair(void *bitmap_id);
extern long    tml_dp_gpr_dflt_cursor_draw(void *bitmap_id, long wherex, long wherey,
                                           long height, long width, long erase);
extern void*   tml_dp_gpr_get_grafsys_obj(void* bitmap_id);
extern char*   get_gpr_default_font_name(long* length);
extern char*   set_gpr_default_font_name(char* font_name, long* length);
#endif

#else
/*default values for default table of rendering functions*/
extern char*   tml_dp_x_get_default_font();
extern char*   tml_dp_x_get_fhandle();
extern long    tml_dp_x_load_font();
extern long    tml_dp_x_get_fcharsize();
extern long    tml_dp_x_get_fcharnum();
extern long    tml_dp_x_get_fchar1();
extern long    tml_dp_x_get_fhi();
extern long    tml_dp_x_get_fpoint();
extern long    tml_dp_x_get_fbline();
extern long    tml_dp_x_is_fixed();
extern short** tml_dp_x_get_fwidths();
extern long    tml_dp_x_get_ficspace();
extern long    tml_dp_x_set_ficspace();
extern long    tml_dp_x_get_fspace();
extern         tml_dp_x_set_fspace();
extern long    tml_dp_x_funload();
extern         tml_dp_x_frelease();
extern char*   tml_dp_x_make_graphic_handle();
extern         tml_dp_x_delete_graphic_handle();
extern long    tml_dp_x_get_hi();
extern long    tml_dp_x_get_wide();
extern long    tml_dp_x_get_foreg_id();
extern long    tml_dp_x_get_backg_id();
extern long    tml_dp_x_get_fill_backg_id();
extern long    tml_dp_x_get_fill_obj_id();
extern         tml_dp_x_set_foreg_id();
extern         tml_dp_x_set_backg_id();
extern         tml_dp_x_set_fill_backg_id();
extern         tml_dp_x_set_fill_obj_id();
extern         tml_dp_x_set_clip();
extern         tml_dp_x_clear_clip();
extern         tml_dp_x_clear();
extern         tml_dp_x_copy();
extern         tml_dp_x_blt();
extern long    tml_dp_x_string_draw();
extern long    tml_dp_x_string_size();
extern         tml_dp_x_damage_repair();
extern long    tml_dp_x_dflt_cursor_draw();
extern char*   tml_dp_x_get_grafsys_obj();
extern char*   get_x_default_font_name();
extern char*   set_x_default_font_name();

/*default values for default table of rendering functions*/
/*  used by GPR, the other default graphics system */
/*  (apollo builds only) */

#ifdef apollo
extern char*   tml_dp_gpr_get_default_font();
extern char*   tml_dp_gpr_get_fhandle();
extern long    tml_dp_gpr_load_font();
extern long    tml_dp_gpr_get_fcharsize();
extern long    tml_dp_gpr_get_fcharnum();
extern long    tml_dp_gpr_get_fchar1();
extern long    tml_dp_gpr_get_fhi();
extern long    tml_dp_gpr_get_fpoint();
extern long    tml_dp_gpr_get_fbline();
extern long    tml_dp_gpr_is_fixed();
extern short** tml_dp_gpr_get_fwidths();
extern long    tml_dp_gpr_get_ficspace();
extern long    tml_dp_gpr_set_ficspace();
extern         tml_dp_gpr_get_fspace();
extern long    tml_dp_gpr_set_fspace();
extern long    tml_dp_gpr_funload();
extern         tml_dp_gpr_frelease();
extern char*   tml_dp_gpr_make_graphic_handle();
extern         tml_dp_gpr_delete_graphic_handle();
extern long    tml_dp_gpr_get_hi();
extern long    tml_dp_gpr_get_wide();
extern long    tml_dp_gpr_get_foreg_id();
extern long    tml_dp_gpr_get_backg_id();
extern long    tml_dp_gpr_get_fill_backg_id();
extern long    tml_dp_gpr_get_fill_obj_id();
extern         tml_dp_gpr_set_foreg_id();
extern         tml_dp_gpr_set_backg_id();
extern         tml_dp_gpr_set_fill_backg_id();
extern         tml_dp_gpr_set_fill_obj_id();
extern         tml_dp_gpr_set_clip();
extern         tml_dp_gpr_clear_clip();
extern         tml_dp_gpr_clear();
extern         tml_dp_gpr_copy();
extern         tml_dp_gpr_blt();
extern long    tml_dp_gpr_string_draw();
extern long    tml_dp_gpr_string_size();
extern         tml_dp_gpr_damage_repair();
extern long    tml_dp_gpr_dflt_cursor_draw();
extern char*   tml_dp_gpr_get_grafsys_obj();
extern char*   get_gpr_default_font_name();
extern char*   set_gpr_default_font_name();
#endif

#endif

#endif
