/**************************************************************************************
    tml_gc_hash.hxx
    header file for the object definitions supporting hash tables

    (c) Copyright Apollo Computer Inc., 1989 (unpublished)
     --------------------------------------------------------------------
    |THE FOLLOWING PROGRAMS ARE THE SOLE PROPERTY OF APOLLO COMPUTER INC.|
    |      AND CONTAIN ITS PROPRIETARY AND CONFIDENTIAL INFORMATION.     |
     --------------------------------------------------------------------
**************************************************************************************/
               
#ifndef tml_gc_hash_hxx
#define tml_gc_hash_hxx

/*hash table and hash table element for garbage collection - hence prefix "gc"*/

const GC_HASH_TBL_SIZE = 0xFF;
const GC_HASH_MASK = (unsigned) 0xFF;
const GC_HASH_SHIFT = 0x04;
                                                  
class gc_hash_elem {
    void *old_ptr;
    void *new_ptr;
    gc_hash_elem *next;
    friend class gc_hash_tbl;
public:
    gc_hash_elem();
    ~gc_hash_elem();
    void set_new(void *ptr) {new_ptr = ptr;};
    };

class gc_hash_tbl {
    gc_hash_elem* tbl[GC_HASH_TBL_SIZE];
public:
    gc_hash_tbl();
    ~gc_hash_tbl();
    void *find(void *ptr);
    gc_hash_elem *insert(void *ptr);
    gc_hash_elem *reset_entry(void* old_ptr, void* new_ptr);
    };   

#endif
